%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PUS GUI %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                              %
% Created by: Ilian Bonev                e-mail: bonev@parallemic.org          %
% Last modified: July 20, 2000                                                 %
%                                                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 IM = 1; %Interactive Mode is active by default
 stop = 1;
 
% THE MESSAGE BOX---------------------------------------------------------------
 OK = '> Admissible pose <';
 MessBox = uicontrol(fig,'Style','text','Pos',[630 400 200 16],...
   'FontWeight','demi','String',OK);
 
% THE <RUN> MENU----------------------------------------------------------------
 Run_menu = uimenu(fig,'Label','Run','Interruptible','on',...
      'CallBack',['if IM == 0,','run=1;,',...
         'while run, refresh(fig); PUS_draw; run=0; end; end;']);

% THE <REFRESH> MENU------------------------------------------------------------
 Refresh_menu = uimenu(fig,'Label','Refresh','CallBack','refresh(fig)');
 
% THE <VIEW> MENU---------------------------------------------------------------
 VP_menu = uimenu(fig,'Label','View');
 VP_submenu1 = uimenu(VP_menu,'Label','iso view','CallBack','view([1,1.5,1])');
 VP_submenu2 = uimenu(VP_menu,'Label','top view','CallBack','view([0,0,-1])');
 VP_submenu3 = uimenu(VP_menu,'Label','front view','CallBack','view([0,-1,0])');
 VP_submenu4 = uimenu(VP_menu,'Label','side view','CallBack','view([1,0,0])');
 
% THE <TRAJECTORY> MENU---------------------------------------------------------
 Traj_menu = uimenu(fig,'Label','Trajectory');
 Traj_submenu0 = uimenu(Traj_menu,'Label','Interactive Mode',...
      'CallBack','IM=1; refresh(fig)');
 Traj_submenu1 = uimenu(Traj_menu,'Label','Trajectory 1','Separator','on');
 Traj_submenu1_rem = uimenu(Traj_submenu1,'Label',...
       'Circular Motion With Constant Tilt Angle','CallBack','IM = 0; traj_01');
 Traj_submenu2 = uimenu(Traj_menu,'Label','Trajectory 2');
 Traj_submenu2_rem = uimenu(Traj_submenu2,'Label',...
       'Circular Zig-Zag Motion','CallBack','IM = 0; traj_02');
 Traj_submenu3 = uimenu(Traj_menu,'Label','Trajectory 3');
 Traj_submenu3_rem = uimenu(Traj_submenu3,'Label',...
       'Horizontal Translational Motion','CallBack','IM = 0; traj_03');
 
% THE QUIT MENU-----------------------------------------------------------------
 Quit_menu = uimenu(fig,'Label','Quit','CallBack',['close(fig);','clear all;']);

% RESETTING THE GENERALIZED COORDINATES-----------------------------------------
 X = 0; Y = 0; Z = -1430; PHI = 0; THE = 0; PSI = 0;

% DEFINE THE X SLIDER-----------------------------------------------------------
 sli_X = uicontrol(fig,'Style','slider','Pos',[670 300 120 17],...
      'Min',-400,'Max',400,'SliderStep',[5/800 50/800],...
      'Val',0,'CallBack',['if IM ==1,','X=round(get(sli_X,''Val''));,'...
         'set(X_cur,''String'',num2str(X)),','traj_00,','PUS_draw,','end']);

% DEFINE THE Y SLIDER-----------------------------------------------------------
 sli_Y = uicontrol(fig,'Style','slider','Pos',[670 250 120 17],...
      'Min',-400,'Max',400,'SliderStep',[5/800 50/800],...
      'Val',0,'CallBack',['if IM ==1,','Y=round(get(sli_Y,''Val''));,'...
         'set(Y_cur,''String'',num2str(Y)),','traj_00,','PUS_draw,','end']);

% DEFINE THE Z SLIDER-----------------------------------------------------------
 sli_Z = uicontrol(fig,'Style','slider','Pos',[670 200 120 17],...
      'Min',-1430,'Max',-600,...
      'Val',-1430,'CallBack',['if IM ==1,','Z=round(get(sli_Z,''Val''));,'...
         'set(Z_cur,''String'',num2str(Z)),','traj_00,','PUS_draw,','end']);

% DEFINE THE PHI SLIDER---------------------------------------------------------
 sli_PHI = uicontrol(fig,'Style','slider','Pos',[670 140 120 17],...
      'Min',-180,'Max',180,'SliderStep',[1/180 1/18],...
      'Val',0,'CallBack',['if IM ==1,','PHI=round(get(sli_PHI,''Val''));,'...
         'set(PHI_cur,''String'',strcat(num2str(PHI),'''')),',...
         'traj_00,','PUS_draw,','end']);

% DEFINE THE THE SLIDER---------------------------------------------------------
 sli_THE = uicontrol(fig,'Style','slider','Pos',[670 90 120 17],...
      'Min',-180,'Max',180,'SliderStep',[1/180 1/18],'Val',0,...
      'CallBack',['if IM ==1,','THE=round(get(sli_THE,''Val''));,'...
         'set(THE_cur,''String'',strcat(num2str(THE),'''')),',...
         'traj_00,','PUS_draw,','end']);

% DEFINE THE PSI SLIDER---------------------------------------------------------
 sli_PSI = uicontrol(fig,'Style','slider','Pos',[670 40 120 17],...
      'Min',-180,'Max',180,'SliderStep',[1/180 1/18],...
      'Val',0,'CallBack',['if IM ==1,','PSI=round(get(sli_PSI,''Val''));,'...
         'set(PSI_cur,''String'',strcat(num2str(PSI),'''')),',...
         'traj_00,','PUS_draw,','end']);

% DEFINE TEXT CONTROL FOR THE MINIMUM VALUES------------------------------------
 X_min = uicontrol(fig,'Style','text','Pos',[637 300 32 17],'String','-400');
 Y_min = uicontrol(fig,'Style','text','Pos',[637 250 32 17],'String','-400');
 Z_min = uicontrol(fig,'Style','text','Pos',[637 200 32 17],'String','-1430');
 PHI_min = uicontrol(fig,'Style','text','Pos',[637 140 32 17],'String','-180');
 THE_min = uicontrol(fig,'Style','text','Pos',[637 90 32 17],'String','-180');
 PSI_min = uicontrol(fig,'Style','text','Pos',[637 40 32 17],'String','-180');

% DEFINE TEXT CONTROL FOR THE MAXIMUM VALUES------------------------------------
 X_max = uicontrol(fig,'Style','text','Pos',[792 300 32 17],'String','+400');
 Y_max = uicontrol(fig,'Style','text','Pos',[792 250 32 17],'String','+400');
 Z_max = uicontrol(fig,'Style','text','Pos',[792 200 32 17],'String','-600');
 PHI_min = uicontrol(fig,'Style','text','Pos',[792 140 32 17],'String','+180');
 THE_min = uicontrol(fig,'Style','text','Pos',[792 90 32 17],'String','+180');
 PSI_min = uicontrol(fig,'Style','text','Pos',[792 40 32 17],'String','+180');

% DEFINE THE SLIDER LABELS------------------------------------------------------
 X_label = uicontrol(fig,'Style','text','Pos',[700 320 20 17],'String','X:');
 Y_label = uicontrol(fig,'Style','text','Pos',[700 270 20 17],'String','Y:');
 Z_label = uicontrol(fig,'Style','text','Pos',[700 220 20 17],'String','Z:');
 PHI_label = uicontrol(fig,'Style','text','Pos',[700 160 20 17],...
     'FontName','Symbol','String','f:');
 THE_label = uicontrol(fig,'Style','text','Pos',[700 110 20 17],...
     'FontName','Symbol','String','q:');
 PSI_label = uicontrol(fig,'Style','text','Pos',[700 60 20 17],...
     'FontName','Symbol','String','y:');

% DEFINE THE TEXT CONTROLS FOR THE CURRENT VALUES-------------------------------
 X_cur = uicontrol(fig,'Style','text','Pos',[722 320 35 17],'String',...
      num2str(get(sli_X,'Value')));
 Y_cur = uicontrol(fig,'Style','text','Pos',[722 270 35 17],'String',...
      num2str(get(sli_Y,'Value')));
 Z_cur = uicontrol(fig,'Style','text','Pos',[722 220 35 17],'String',...
      num2str(get(sli_Z,'Value')));
 PHI_cur = uicontrol(fig,'Style','text','Pos',[722 160 35 17],'String',...
      strcat(num2str(get(sli_PHI,'Value')),''));
 THE_cur = uicontrol(fig,'Style','text','Pos',[722 110 35 17],'String',...
      strcat(num2str(get(sli_THE,'Value')),''));
 PSI_cur = uicontrol(fig,'Style','text','Pos',[722 60 35 17],'String',...
      strcat(num2str(get(sli_PSI,'Value')),''));

% DEFINE THE RESET PUSH BUTTON--------------------------------------------------
 pbreset = uicontrol(fig,'Style','push','Pos',[701 350 60 22],...
      'String','RESET','CallBack',['if IM == 1,',...
        'set(sli_X,''Value'',0),','set(sli_Y,''Value'',0),',...
        'set(sli_Z,''Value'',-1430),','set(sli_PHI,''Value'',0),',...
        'set(sli_THE,''Value'',0),','set(sli_PSI,''Value'',0),',...
        'set(X_cur,''String'',''0''),','set(Y_cur,''String'',''0''),',...
        'set(Z_cur,''String'',''-1430''),','set(PHI_cur,''String'',''0''),',...
        'set(THE_cur,''String'',''0''),','set(PSI_cur,''String'',''0''),',...
        'X = 0; Y = 0; Z = -1430; PHI = 0; THE = 0; PSI = 0;',...
        'refresh(fig); traj_00; PUS_draw;','end;']);
