%%%%%%%%%%%%%%%%%%%%%%%% INVERSE KINEMATICS SUBROUTINE %%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                              %
% Created by: Ilian Bonev                e-mail: bonev@parallemic.org          %
% Last modified: July 20, 2000                                                 %
%                                                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% M A I N  L O O P _____________________________________________________________
 for j=1:num_steps,

% TRANSFORMATION OF PLATFORM COORDINATES----------------------------------------
 B = C(:,j)*ones(1,6) + R(:,:,j)*Bp;

% PLOTTING THE PLATFORM---------------------------------------------------------
 set(plat,'xdata',[B(1,:),B(1,1)],'ydata',[B(2,:),B(2,1)], ...
	  'zdata',[B(3,:),B(3,1)]);

% CALCULATION OF INTERMIDIATE PARAMETERS----------------------------------------
 param1 = (B-A0);
 param2 = param1(1,:).^2+param1(2,:).^2+param1(3,:).^2;
 for i=1:6, param3(i) = a(:,i)'*param1(:,i); end;
 param4 = param3.^2-param2+ls;
 if any(param4<0),
   sound(2*cos(0:pi/30:10*pi));
   set(MessBox,'String','> Leg Lengths Constraint! <','ForegroundColor','red');
   break;
 end;
 
% CALCULATION OF BASE JOINTS POSITIONS------------------------------------------
 lambda = param3 - sqrt(param4);
 if any(lambda>700) | any(lambda<0),
   sound(2*cos(0:pi/30:10*pi));
   set(MessBox,'String','> Out of Actuator Limits! <','ForegroundColor','red');
   break;
 end;
 for i =1:6, A(:,i) = A0(:,i)+lambda(i)*a(:,i); end;

% PLOTTING OF LEGS--------------------------------------------------------------
 set(leg1,'xdata',[A(1,1);B(1,1)],'ydata',[A(2,1);B(2,1)], ...
          'zdata',[A(3,1);B(3,1)]);
 set(leg2,'xdata',[A(1,2);B(1,2)],'ydata',[A(2,2);B(2,2)], ...
          'zdata',[A(3,2);B(3,2)]);
 set(leg3,'xdata',[A(1,3);B(1,3)],'ydata',[A(2,3);B(2,3)], ...
          'zdata',[A(3,3);B(3,3)]);
 set(leg4,'xdata',[A(1,4);B(1,4)],'ydata',[A(2,4);B(2,4)], ...
          'zdata',[A(3,4);B(3,4)]);
 set(leg5,'xdata',[A(1,5);B(1,5)],'ydata',[A(2,5);B(2,5)], ...
          'zdata',[A(3,5);B(3,5)]);
 set(leg6,'xdata',[A(1,6);B(1,6)],'ydata',[A(2,6);B(2,6)], ...
          'zdata',[A(3,6);B(3,6)]);

% PLOTTING OF TOOL--------------------------------------------------------------
 C0 = C(:,j) + R(:,:,j)*C0p;
 set(tool,'xdata',[C(1,j);C0(1)],'ydata',[C(2,j);C0(2)],'zdata',[C(3,j);C0(3)]);
 set(tooltip,'xdata',[C(1,j);C(1,j)],'ydata',[C(2,j);C(2,j)],...
              'zdata',[C(3,j);C(3,j)]);

 drawnow
 set(MessBox,'String',OK,'ForegroundColor','black');
 end
% M A I N  L O O P _____________________________________________________________
