%%%%%%%%%%%%%%%%%%%%%%%%%%% CIRCULAR ZIG-ZAG MOTION %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                              %
% Created by: Ilian Bonev                e-mail: bonev@parallemic.org          %
% Last modified: July 20, 2000                                                 %
%                                                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% TRAJECTORY PARAMETERS---------------------------------------------------------
 s1 = 8; s2 = 30; s3 = 100; s4 = s2; s5 = s1;  % substeps
 num_steps = s1 + s2 + s3 + s4 + s5;  % number of defined trajectory points

% Z-MOTION----------------------------------------------------------------------
 for i = 1:s1;
  C(:,i) = [0.000; 0.000; -660 - 30*i];
  R(:,:,i) = RotMat(0, 0, 0);
 end;

% ZX-MOTION + TILT ANGLE CHANGE-------------------------------------------------
 for i = (s1+1):(s1+s2);
  C(:,i) = [150*(i-s1)/s2; 0.000; C(3,s1)-10*(i-s1)];
  theta = (pi/6)*(i-s1)/s2;
  R(:,:,i) = RotMat(pi/2, theta, 0);
 end;

% ZIG-ZAG MOTION----------------------------------------------------------------
 for i = (s1+s2+1):(s1+s2+s3);
  t = i-s1-s2;
  C(:,i) = [150-300*t/100;70*sin(2*pi*t/50); ...
	    -1210-(372-sqrt(160000-(150-300*t/100)^2))];
  R(:,:,i) = RotMat(pi/2, theta-(pi/3)*t/100, 0);
 end;

% RETURN MOTION-----------------------------------------------------------------
 for i = (s1+s2+s3+1):(s1+s2+s3+s4);
  C(:,i) = [-150+150*(i-s1-s2-s3)/s4; 0.000; C(3,s1+s2+s3)+10*(i-s1-s2-s3)];
  theta = (pi/6)-(pi/6)*(i-s1-s2-s3)/s4;
  R(:,:,i) = RotMat(-pi/2, theta, 0);
 end;

% RETURN MOTION-----------------------------------------------------------------
 for i = (s1+s2+s3+s4+1):num_steps;
  C(:,i) = [0.000; 0.000; C(3,s1+s2+s3+s4) + 30*(i-s1-s2-s3-s4)];
  R(:,:,i) = RotMat(0, 0, 0);
 end;
