%%%%%%%%%%%%%%%%%%%%%%%% HORIZONTAL TRANSLATIONAL MOTION %%%%%%%%%%%%%%%%%%%%%%%
%                                                                              %
% Created by: Ilian Bonev                e-mail: bonev@parallemic.org          %
% Last modified: July 20, 2000                                                 %
%                                                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% TRAJECTORY PARAMETERS---------------------------------------------------------
 s1 = 20; s2 = 20; s3 = 2*s2; s4 = s2; s5 = s1;  % number of substeps
 num_steps = s1 + s2 + s3 + s4 + s5;  % number of total steps

% Z-MOTION (Down)---------------------------------------------------------------
 for i = 1:s1;
   C(:,i) = [0.000; 0.000;-660 - 20*i];
   R(:,:,i) = RotMat(0, 0, 0);
 end;

% X-MOTION (to the Left)--------------------------------------------------------
 for i = (s1+1):(s1+s2);
   C(:,i) = [15*(i-s1); 0.000; C(3,s1)];
   R(:,:,i) = RotMat(0, 0, 0);
 end;

%X-MOTION (to the Right)--------------------------------------------------------
 for i = (s1+s2+1):(s1+s2+s3);
  C(:,i) = [C(1,s1+s2) - 15*(i-s1-s2); 0.000; C(3,s1)];
  R(:,:,i) = RotMat(0, 0, 0);
 end;

% X-MOTION (back to the Left)---------------------------------------------------
 for i = (s1+s2+s3+1):(s1+s2+s3+s4);
  C(:,i) = [C(1,s1+s2+s3) + 15*(i-s1-s2-s3); 0.000; C(3,s1)];
  R(:,:,i) = RotMat(0, 0, 0);
 end;

% Z-MOTION (Up)-----------------------------------------------------------------
 for i = (s1+s2+s3+s4+1):num_steps;
   C(:,i) = [0.000; 0.000; C(3,s1) + 20*(i-s1-s2-s3-s4)];
   R(:,:,i) = RotMat(0, 0, 0);
 end;
